Loading...
Searching...
No Matches
libthreadar Namespace Reference

This is the only namespace used in libthreadar and all symbols provided by libthreadar are member of this namespace. More...

## Classes

class | barrier
| the class barrier allows several threads to synchronize between them More...
class | condition
| Wrapper around the Posix pthread_cond_t object and its associated mutex. More...
class | exception_base
| Pure virtual class parent of all libthreadar exceptions. More...
class | exception_bug
| Exception used to report webdar internal bugs. More...
class | exception_feature
| Exception used to report an non-implemented feature. More...
class | exception_memory
| Exception used to report memory allocation failures. More...
class | exception_range
| Exception used to report out or range value or argument. More...
class | exception_system
| Exception used to report operating system errors. More...
class | exception_thread
| Exception used to report error met when manipulating threads. More...
class | fast_tampon
| Class fast_tampon provides asynchronous communication between two threads. More...
class | freezer
| Class freezer is a semaphore like construct that has no maximum value. More...
class | mutex
| Wrapper around the Posix pthread_mutex_t C objects. More...
class | ratelier_gather
| the class ratelier_gather's purpose it gather works from several worker threads More...
class | ratelier_scatter
| The class ratelier_scatter's purpose it to scatter an ordered set of data to many worker threads. More...
class | semaphore
| Class semaphore is an enhanced version of Posix semaphore. More...
class | tampon
| DEPRECATED see fast_tampon instead! More...
class | thread
| Class thread is a pure virtual class, that implements thread creation and operations. More...
class | thread_signal
| Class thread_signal provides the same interface as class thread but in addition relies on a signal to awake the tread if it was pending on a system call. More...

## Functions

template<class T >
exception_base * | cloner (void *const ptr)
| Template used by libthreadar to implement the clone() method for libthreadar exceptions.
void | get_version (unsigned int &major, unsigned int &medium, unsigned int &minor)
| provides the version of libthreadar
template<class T >
std::string | tools_convert_to_string (T val)

## Detailed Description

This is the only namespace used in libthreadar and all symbols provided by libthreadar are member of this namespace.

## Function Documentation

## cloner()

template<class T >

exception_base * libthreadar::cloner | ( | void *const | ptr | ) |

Template used by libthreadar to implement the clone() method for libthreadar exceptions.

Definition at line 160 of file exceptions.hpp.

## get_version()

void libthreadar::get_version | ( | unsigned int & | major,
|  | unsigned int & | medium,
|  | unsigned int & | minor
| ) |  |

extern

provides the version of libthreadar

Parameters

  [out] | major | is incremented when the API changes in a way it becomes incompatible with previous API so user program have to be adapted to be used with it else they might even not compile.
  [out] | medium | is incremented when new features are added to the library in a way it stays compatible with previous version of the API (user program should not need to be modified nor recompiled)
  [out] | minor | is incremented when bug fix is brought to the library without any new feature or feature enhancment nor API modification.

## tools_convert_to_string()

template<class T >

std::string libthreadar::tools_convert_to_string | ( | T | val | ) |

Definition at line 43 of file tools.hpp.